#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    long long n, k, d;
    cin >> n >> k;
    while (k--)
    {
        cin >> d;
        long long res = 0;
        for (long long i = 1; i <= d; i++)
        {
            if (d % i == 0) res = res^i;
        }
        cout << res << endl;
    }
    return 0;
}